#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <fcntl.h>
#include <termios.h>
#include <string.h> // needed for memset

#include <time.h>
#include <locale.h>



	void DelayMs(unsigned int t);
	void PrintSerial(char *cadena);
	int fdrs232;

#define BUF_SIZE 200

int segundo,hora,minuto,diaMes,diaSemana,mes,ano;


int main(int argc,char** argv)
{
        struct termios tio;
        struct termios stdio;
        struct termios oldAtri;
        fd_set rdset;

        unsigned char c='D';
        
            printf("Please start with %s /dev/ttyUSB0 (for example) Q-Exit\n",argv[0]);  
			printf("_________DCF_______\n");

			time_t t;
			struct tm *loc;
			char buf[BUF_SIZE];

//Configurar SERIE									
			memset(&tio,0,sizeof(tio));
			tio.c_iflag=0;
			tio.c_oflag=0;
			tio.c_cflag=CS8|CREAD|CLOCAL;           // 8n1, see termios.h for more information
			tio.c_lflag=0;
			tio.c_cc[VMIN]=1;
			tio.c_cc[VTIME]=5;

			fdrs232=open(argv[1], O_RDWR | O_NONBLOCK);        // O_NONBLOCK might override VMIN and VTIME, so read() may return immediately.
			if (fdrs232 <0)	{printf("Error %s puerto de comunicaciones\n",argv[1]);	goto error1;	}
			cfsetospeed(&tio,B9600);            // 9600 baud
			cfsetispeed(&tio,B9600);            // 9600 baud
			tcsetattr(fdrs232,TCSANOW,&tio);			

			//Vacío el buffer de entrada.
			if(tcflush(fdrs232,TCIFLUSH) == -1){printf("Error TCI\n"); goto error1; }
			//Vacío el buffer de salida.
			if(tcflush(fdrs232,TCOFLUSH) == -1){printf("Error lTCO\n"); goto error1;}
//--------------------
			  
			PrintSerial((char *) "STOP\n");
			for(int z;z<1000;z++) {read(fdrs232,&c,1);  DelayMs(2);}  		  
			
			if (setlocale(LC_ALL, "") == NULL)      { printf("Error locate!\n"); goto error1;}
			t = time(NULL);
			loc = localtime(&t);
			if (loc == NULL)       { printf("Error locateTime!\n");  goto error1;}
			printf("Local time is:  %s", asctime(loc));
			if (strftime(buf, BUF_SIZE, "%A, %d %B %Y, %H:%M:%S %Z", loc) == 0) 
						{ printf("Error strftime returned !\n"); goto error1;}
			segundo=loc->tm_sec;
			hora=loc->tm_hour;
			minuto=loc->tm_min;
			ano=loc->tm_year+1900;
			mes=loc->tm_mon;
			diaMes=loc->tm_mday;
			diaSemana=loc->tm_wday;

			PrintSerial((char *) "STOP\n");
			sprintf(buf,"diaMes=%d\n",diaMes); PrintSerial(buf);
			sprintf(buf,"diaSemana=%d\n",diaSemana); PrintSerial(buf);
			sprintf(buf,"ano=%d\n",ano); PrintSerial(buf);
			sprintf(buf,"hora=%d\n",hora); PrintSerial(buf);
			sprintf(buf,"minuto=%d\n",minuto); PrintSerial(buf);
			sprintf(buf,"segundo=%d\n",segundo); PrintSerial(buf);	
			PrintSerial((char *) "START\n");	

//Configurar teclado			
			if(tcgetattr(STDIN_FILENO, &oldAtri) < 0) {	perror("stdin");  goto error0;}			
			memset(&stdio,0,sizeof(stdio));
			stdio.c_iflag=0;
			stdio.c_oflag=0;
			stdio.c_cflag=0;
			stdio.c_lflag=0;
			stdio.c_cc[VMIN]=1;
			stdio.c_cc[VTIME]=0;
			tcsetattr(STDOUT_FILENO,TCSANOW,&stdio);
			tcsetattr(STDOUT_FILENO,TCSAFLUSH,&stdio);
			fcntl(STDIN_FILENO, F_SETFL, O_NONBLOCK);       // make the reads non-blocking
//---------				
			
			while (c!='q' && c!='Q')
			{
					if (read(fdrs232,&c,1)>0)        write(STDOUT_FILENO,&c,1);  // if new data is available on the serial port, print it out
					if (read(STDIN_FILENO,&c,1)>0)  write(fdrs232,&c,1);         // if new data is available on the console, send it to the serial port
			}

			close(fdrs232);					
error0:
			tcsetattr(STDOUT_FILENO,TCSANOW,&oldAtri);
			tcsetattr(STDOUT_FILENO,TCSAFLUSH,&oldAtri);	
error1:		
			printf("\nEND_DCF_____\n");     
}


#if YesWindows
		void	DelayMs(unsigned int t)
				{
					Sleep(t);
				}
#else
		void	DelayMs(unsigned int t)
				{
					usleep(t*1000);
				}
#endif


void PrintSerial(char *cadena)
{
 int tama;
			tama=strlen(cadena);

#if YesWindows
			WriteSerie(hSerial,cadena,tama);
#else
			write(fdrs232,cadena,tama);
#endif
}
